//=================================================================================================
//							Конвертирование переменных в строки  (без форматирования)
//=================================================================================================
//=================================================================================================
//							byte->BIN
//=================================================================================================
String byteToBin(uint8_t v) {
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
uint8_t Qnt=mess.qntBit;  if(Qnt==0) {Qnt=8;} if(Qnt>8) {Qnt=8;} //==Нормализация кол-во выводимых бит;
String str; uint8_t len=0; bool a; uint8_t val=0;
if(mess.orderBit=='F'){val=v;} else {val=0; for(uint8_t i=1; i<=Qnt; i++) {bitWrite(val,(i-1),bitRead(v,(Qnt-i)));}}
if(mess.signBit==0){str=String('b'); len++;}  //if(Qnt>4){len++;}; 
for(uint8_t i=1; i<=Qnt; i++) {a=bitRead(val,(Qnt-i)); //if((((Qnt-i+1)==4)) && (i!=1)){str+=" ";}
if(a){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
else {str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode));}} 
return str;};		
//=================================================================================================
//							word->BIN
//=================================================================================================
String wordToBin(uint16_t v){
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
uint8_t Qnt=mess.qntBit;  if(Qnt==0) {Qnt=16;} if(Qnt>16) {Qnt=16;} //==Нормализация кол-во выводимых бит;
String str; uint8_t len=0; bool a; uint16_t val=0;
if(mess.orderBit=='F'){val=v;} else {val=0; for(uint8_t i=0; i<=Qnt; i++) {bitWrite(val,(i-1),bitRead(v,(Qnt-i)));}}
if(mess.signBit==0){str=String('b'); len++;} //if(Qnt>8){len++;};
for(uint8_t i=1; i<=Qnt; i++){a=bitRead(val,(Qnt-i)); //if((((Qnt-i+1)==8)) && (i!=1)){str+=" ";}
if(a){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
else {str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode));}} 
//consoleVar(Qnt,','); consoleVar(str,'E'); 
return str;};
//=================================================================================================
//							long->BIN
//=================================================================================================
String longToBin(uint32_t v){
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
uint8_t Qnt=mess.qntBit;  if(Qnt==0) {Qnt=32;} if(Qnt>32) {Qnt=32;} //==Нормализация кол-во выводимых бит;
String str; uint8_t len=0; bool a; uint32_t val=0;
if(mess.orderBit=='F'){val=v;} else {val=0; for(uint8_t i=0; i<=Qnt; i++) {bitWrite(val,(i-1),bitRead(v,(Qnt-i)));}}
if(mess.signBit==0){str=String('b'); len++;} //if(Qnt>8){len++;};
for(uint8_t i=1; i<=Qnt; i++){a=bitRead(val,(Qnt-i)); //if((((Qnt-i+1)==8)) && (i!=1)){str+=" ";}
if(a){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
else {str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode));}} 
//consoleVar(Qnt,','); consoleVar(str,'E'); 
return str;};
//=================================================================================================
//							0-100%->Line
//=================================================================================================
String byteToLine(uint8_t val){
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
String str=""; 
uint8_t Qnt=mess.qntBit;   if(Qnt==0){return str;} 
uint8_t a=val; if(a>100) {a=100;} 
a=((uint16_t)a*mess.qntBit)/100; 
for(uint8_t i=1; i<=a; i++){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 

//consoleVar(String("Line=")); consoleVar(str,'E');


return str;};
//=================================================================================================
//							byte->PIN [mess.modePin::T,A,D]
//=================================================================================================
String pinToString(uint8_t  v){
String str="";
//-------------------------------------
#if defined(RT_HW_CORE_STM32)	
if(mess.modePin=='T') {str=getNamePin(v)+" "; 			return str;}
if(mess.modePin=='A') {str=getNamePin(v)+String('[');
						  if(v<254) {str+=String(v);} else{str+=String('*');} str+=String(']'); return str;}
//-------------------------
if(v<254) {str+=String(v);} else{str+=String('*');}    	return str;                    
//-------------------------------------
#elif defined(RT_HW_CORE_ESP8266)
if(mess.modePin=='T') {str=getNamePin(v); 			return str;}
if(mess.modePin=='A') {str=getNamePin(v)+String('[');
						  if(v<254){str+=String(v);} else{str+=String('*');} str+=String(']');  return str;}
//-------------------------------------
                          if(v<254){str =String(v);} else{str= String('*');} return str;
//-------------------------------------
#else
                          if(v<254){str+=String(v);} else{str= String(' ')+String('*');} return str; 	 		 
#endif		  
return str;};
//=================================================================================================
//							byte->adr.i2c [mess.modePin::D,H,A]
//=================================================================================================
String adrToString(uint8_t  v){	
String str;
//-------------------------------------------------------------------------------------------------
if(mess.modeAdr=='H') {if(v<=127){str=String(F("0x")); if(v<0x0F) {str+=String('0');} str+=String(v,HEX);} 
                                                          else       {str=String(F(" ** "));}    return str;} 
//-------------------------------------------------------------------------------------------------
if(mess.modeAdr=='A') {if(v<=127){str=String(F("0x")); if(v<0x0F) {str+=String('0');} str+=String(v,HEX);} 
                                                          else {str=String(F(" ** "));} 
														  str+=String('/')+String(v);            return str;}
//-------------------------------------------------------------------------------------------------
str=String(v); return str;};
//-------------------------------------------------------------------------------------------------
//=================================================================================================
