//=================================================================================================
//					Конвертирование переменной bool в char [mode='0'-'9']
//=================================================================================================		
char boolToChar(bool v){	
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
if(v){return (char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode);} 
else {return (char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode);}};
//=================================================================================================
//					Конвертирование переменной char в char char [mode:u,l,Z]
//=================================================================================================
String charToString(char v, char mode='Z'){	
String str=String(v);	
if(mode=='u'){str.toUpperCase();}
if(mode=='l'){str.toLowerCase();}
return str;};
//=================================================================================================
//					Конвертирование переменной uint8_t [mode:P,A,C,B,*,H,U,I,T,W,Z,z,1]
//=================================================================================================
String varToString(uint8_t v, char mode='Z'){	
String str=String(v);	
uint8_t sz=mess.size;
char alig=mess.alig; 	
char signBit=mess.signBit; 
char orderBit=mess.orderBit; 
char qntBit=mess.qntBit; if(mess.qntBit>8) {mess.qntBit=8;}
//-------------------------------------
if(mode=='P') {str=pinToString(v);  mess.alig='R';
  if(sz==0) {mess.alig='N';} else{
#if defined(RT_HW_CORE_STM32)
if(sz<3) {sz=3;}
if(mess.modePin=='A') {if(sz<8) {sz=9;} mess.alig='L';}
if(mess.modePin=='T') {if(sz<4) {sz=4;} mess.alig='L';}
#endif
#if defined(RT_HW_CORE_ESP8266)
if(sz<2) {sz=2;}
if(mess.modePin=='A') {if(sz<7) {sz=7;}}
if(mess.modePin=='T') {if(sz<3) {sz=3;}}
#endif
}}
//-----------------------------------
if(mode=='A') {str=adrToString(v);}
if(mode=='B') {mess.orderBit='F'; str=byteToBin(v);} 
if(mode=='*') {mess.orderBit='B'; str=byteToBin(v);}			
if(mode=='H') {str=String(v,HEX); str.toUpperCase(); if(v<=0xF){str="0"+str;} str="0x"+str;}
if(mode=='U') {str=String(v);}								
if(mode=='I') {str=String(int8_t(v));}
if(mode=='T') {str=String(v); if(v<10)  {str=String("0")+str;}}
if(mode=='W') {mess.alig='N'; if(v<254) {str=String(v);} else {str=String('*');}}
if(mode=='z') {mess.alig='N'; str=String((uint8_t)v);}
if(mode=='Z') {mess.alig='N'; str=String(int8_t(v));}
if(mode=='1') {str=String(float(int8_t(v)/10.0),1);}
if(mode=='X') {str=byteToLine(v);}
if(mode=='C') {str=String(char(v));}
mess.alig=alig;  mess.signBit=signBit; mess.orderBit=orderBit; mess.qntBit=qntBit;
return str;}
//----------------------------------------
String varToString(int8_t v, char mode='Z'){return varToString((uint8_t)v,mode);}
//=================================================================================================
//					Конвертирование переменной int16_t [mode:B,*,H,U,I,0,1,2,3,Z,z]
//=================================================================================================	
String varToString(int16_t v, char mode='Z'){	
String str=String(v); 
char signBit=mess.signBit; char orderBit=mess.orderBit; char qntBit=mess.qntBit;
if(mode=='B') {mess.orderBit='F'; 		str=wordToBin(uint16_t(v));} 
if(mode=='*') {mess.orderBit='B';		str=wordToBin(uint16_t(v));} 				
if(mode=='H') {str=String((uint16_t)v,HEX); str.toUpperCase(); uint8_t len=str.length(); for(uint8_t i=len; i<4; i++){str="0"+str;} str="0x"+str;}
if(mode=='U') {str=String(uint16_t(v));}								
if(mode=='I') {str=String(v);}	
if(mode=='0') {str=String(float(v/1.0),0)+String(F(".0"));}
if(mode=='1') {str=String(float(v/10.0),1);}
if(mode=='2') {str=String(float(v/100.0),2);}
if(mode=='3') {str=String(float(v/1000.0),3);}
if(mode=='z') {mess.alig='N'; str=String(uint16_t(v));}
if(mode=='Z') {mess.alig='N'; str=String( int16_t(v));}
mess.signBit=signBit; 		mess.orderBit=orderBit; 	mess.qntBit=qntBit;
return str;}
//=================================================================================================
//					Конвертирование переменной uint16_t [mode:B,*,H,U,I,0,1,2,3,Z,z]
//=================================================================================================
String varToString(uint16_t v, char mode='Z'){return varToString((int16_t)v,mode);}
//=================================================================================================
//					Конвертирование переменной int32_t [mode:U,I,0,1,2,3,Z,z]
//=================================================================================================	
String varToString(int32_t v, char mode='Z'){	
String str=String(v);	
char signBit=mess.signBit; char orderBit=mess.orderBit; char qntBit=mess.qntBit; 				
if(mode=='B') {mess.orderBit='F'; 		str=longToBin(uint32_t(v));} 
if(mode=='*') {mess.orderBit='B';		str=longToBin(uint32_t(v));} 
if(mode=='H') {str=String((uint32_t)v,HEX); str.toUpperCase(); uint8_t len=str.length(); for(uint8_t i=len; i<8; i++){str="0"+str;} str="0x"+str;}
if(mode=='U') {str=String(uint32_t(v));}								
if(mode=='I') {str=String( int32_t(v));}	
if(mode=='0') {str=String(float(v/1.0),0)+String(F(".0"));}
if(mode=='1') {str=String(float(v/10.0),1);}
if(mode=='2') {str=String(float(v/100.0),2);}
if(mode=='3') {str=String(float(v/1000.0),3);}
if(mode=='z') {mess.alig='N'; str=String(uint32_t(v));}
if(mode=='Z') {mess.alig='N'; str=String(int32_t(v));}
mess.signBit=signBit; 		mess.orderBit=orderBit; 	mess.qntBit=qntBit;
return str;}
//=================================================================================================
//					Конвертирование переменной uint32_t [mode:U,I,0,1,2,3,Z,z]
//=================================================================================================	
String varToString(uint32_t v, char mode='Z'){return varToString((int32_t)v, mode);}
//=================================================================================================
//					Конвертирование переменной float [mode:0,1,2,3,Z]
//=================================================================================================	
String varToString(float v, char mode='2'){		
 String str=String(v,2);		 	
if(mode=='0') {str=String(v,0);}
if(mode=='1') {str=String(v,1);}
if(mode=='2') {str=String(v,2);}
if(mode=='3') {str=String(v,3);}
if(mode=='Z') {str=String(v,2);}	
return str;};
//=================================================================================================
//					КОНСОЛЬ: Форматированный вывод переменной String [mode:u,l,Z]
//=================================================================================================	
String varToString(String v, char mode='Z'){		
String str=v; 	
if(mode=='u') {str.toUpperCase();}
if(mode=='l') {str.toLowerCase();}
return str;};
//=================================================================================================
