//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 								Выбор режима работы без периода
//uint8_t dir=0; uint8_t state:4,first:1,agoeN:1,exteN:1,extEN:1;
// mode: С-по изменению входных переменных;
//       E-по переднему фронту;
//       S-переднему фронту;
//       
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void FLProgCheckEventSimple(RT_HW_CLASS_FLPROG_CHECK &id, char modeOutput){
//-------------------------------------------------------------------------------------------------
id.state=0;
if(!id.extEN)  {id.first=0; return;}
if(id.first==0){id.first=1; id.state=1; id.agoeN=id.exteN; return;}  
//-------------------------------------------------------------------------------------------------
if(modeOutput=='C'){id.state=2; return;}
if(modeOutput=='E'){id.state=1; return;}
if(modeOutput=='S'){if(id.agoeN!=id.exteN){id.agoeN=id.exteN; if(id.agoeN){id.state=1;}} return;} 
if(modeOutput=='F'){return;} //--Выполняется по first=0;
if(modeOutput=='N'){return;} 
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 								Выбор режима работы без периода
//uint8_t dir=0; uint8_t state:4,first:1,agoeN:1,exteN:1,extEN:1;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void FLProgCheckEvent(RT_HW_CLASS_FLPROG_CHECK &id, char modeOutput){
//-------------------------------------------------------------------------------------------------
id.state=0;
if(!id.extEN)  {id.first=0; return;}
if(id.first==0){id.first=1; id.state=1; id.agoeN=id.exteN; return;}  
//-------------------------------------------------------------------------------------------------
if(modeOutput=='C'){id.state=2; return;}
if(modeOutput=='E'){id.state=1; return;}
if(modeOutput=='S'){if(id.agoeN!=id.exteN){id.agoeN=id.exteN; if(id.agoeN){id.state=1;}} return;} 
if(modeOutput=='F'){return;} //--Выполняется по first=0;
if(modeOutput=='N'){return;} 
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 								Выбор режима работы с периодом
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void FLProgCheckEvent(RT_HW_CLASS_FLPROG_CHECK &id,uint32_t &timeBegin, char modeOutput, uint16_t period){
//-------------------------------------------------------------------------------------------------
if(id.state==3){timeBegin=millis();}
id.state=0;
if(!id.extEN)  {id.first=0; return;}
if(id.first==0){id.first=1; id.state=1; id.agoeN=id.exteN; return;}  
//-------------------------------------------------------------------------------------------------
if(modeOutput=='C'){id.state=2; return;} 													//--По изменению во внешней функции;
if(modeOutput=='P'){if(periodMs(timeBegin,period)){id.state=1;} return;}				  	//--Периодически;
if(modeOutput=='T'){if(periodMs(timeBegin,period)){id.state=2;} return;}				  	//--Периодически и   по изменению во внешней функции; 
if(modeOutput=='A'){if(periodMs(timeBegin,period)){id.state=1;} else{id.state=2;}return;} 	//--Периодически или по изменению во внешней функции; 
if(modeOutput=='E'){id.state=1; return;}													//--В каждом цикле;
if(modeOutput=='S'){if(id.agoeN!=id.exteN){id.agoeN=id.exteN; if(id.agoeN){id.state=1;}} return;} //--По переднему фронту;
if(modeOutput=='F'){return;} 																//--Выполняется однократно по first=0;
if(modeOutput=='N'){return;} 																//--Не выполняется;
return;
} 