//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            			MCP4725 (DAC)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_MCP4725_VER  	 		11	//--Номер версии библиотеки;
#define RT_HW_MCP4725_DELAY_ERR     50 	//--Базовая задержка при повторов после ошибки;
//=================================================================================================
//							Управление измерением
//=================================================================================================
void mcp4725(RT_HW_STRUCT_MCP4725_ID &z){
//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {if(!z.run) {return;}; 
			  z.ok=0; z.vDAC=0; z.dir++;}		 	//--Начальные параметры ;
if(z.dir==1) {z.codeErr=i2cInitMaster(z.bus); 		//--Настройка шины i2c;
			  if(z.codeErr){z.dir=95; return;}		//--Выход по ошибке;
              z.sizeDelay=0; z.dir=5;}				//--Подготовка параметров и переход;	
//-------------------------------------------------------------------------------------------------
// 							Поиск устройства на шине i2c
//-------------------------------------------------------------------------------------------------
if(z.dir==5) {if(i2cFindAdr(z.timeBegin,z.sizeDelay,z.adr,z.bus)){z.dir=20;} return;}		//--Переход;			  
//-------------------------------------------------------------------------------------------------
// 							Ожидание флагов запуска измерений
//-------------------------------------------------------------------------------------------------
if(z.dir==20){if(z.run){z.run=0; z.dir++;} else {return;}}				
if(z.dir==21){uint8_t data[3]; 
			  if(z.vEEPROM) {data[0]=0x60;} else{data[0]=0x40;}
			  data[1]= (z.vDAC / 16);
			  data[2]=((z.vDAC % 16) <<4);
			  z.codeErr=i2cSendBytes(data,3,z.adr,z.bus); if(z.codeErr){z.dir=50; return;}	//--Выход по ошибке;
			  z.ok=1;													z.dir++;  return;} 	//--Обработка результата;
if(z.dir==22){if(!timeDelay(z.timeBegin,z.stepDelay,5)){return;}        z.dir=20; return;}	//--Задержка 10мс;	
//-------------------------------------------------------------------------------------------------
// 					Динамическая задержка с последующим возвратом на цикл измерения
//-------------------------------------------------------------------------------------------------
if(z.dir==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_BH1750_DELAY_ERR; z.dir++;}}	//--Контроль повторных ошибок;
if(z.dir==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.dir=0; return;}
//-------------------------------------------------------------------------------------------------
}
//=================================================================================================
