//=================================================================================================
//=================================================================================================
//							WriteByte[]
//=================================================================================================
void LcdWriteByte(RT_HW_HD44780_PARAM_ID &id, char alig, const char *head, char suff, uint8_t &ago, uint8_t var, char mode, char sign='X'){
if(LcdFuncBegin(id)) 					{return;}
if(id.dir==9){if(ago!=var){id.fresh=1;} 
			  if(!id.fresh)   {id.dir=1; return;} //--return if fresh=0;
			  ago=var; 
			  if(mode=='X'){if(id.fistLine){id.fistLine=id.lenVar=0;} else {id.lenVar=id.len-id.lenHead-id.lenSuff;} id.lenVar=((uint16_t)ago*id.lenVar)/100;}
			  else         {RT_HW_Base.mess.signBit='1'; RT_HW_Base.mess.qntBit=id.len; if(RT_HW_Base.mess.qntBit>8){RT_HW_Base.mess.qntBit=8;}; String str =RT_HW_Base.varToString(var,mode); id.lenVar=str.length();
			  } 			   id.dir=10;} 
if(LcdFuncBefore(id,alig,head,suff))	{return;}
if(LcdFuncByte(id,ago,mode,sign))		{return;}
if(LcdFuncAfter(id,alig,suff))			{return;}};
//=================================================================================================
//							WriteWord[mode:F,R,C]
//=================================================================================================
void LcdWriteWord(RT_HW_HD44780_PARAM_ID &id, char alig, const char *head, char suff, int16_t &ago, int16_t var, char mode){
if(LcdFuncBegin(id)) 					{return;}
if(id.dir==9){if(ago!=var){id.fresh=1;} 
			  if(id.fresh){ago=var; id.lenVar=RT_HW_Base.varToString(var,mode).length(); 	id.dir=10;} else{id.dir=1; return;}}
if(LcdFuncBefore(id,alig,head,suff))	{return;}
if(LcdFuncWord(id,ago,mode))			{return;}
if(LcdFuncAfter(id,alig,suff))		 	{return;}};
//=================================================================================================
//							WriteLong
//=================================================================================================
void LcdWriteLong(RT_HW_HD44780_PARAM_ID &id, char alig, const char *head, char suff, int32_t &ago, int32_t var, char mode){
if(LcdFuncBegin(id)) 					{return;}
if(id.dir==9){if(ago!=var) {id.fresh=1;} 
			  if(id.fresh) {ago=var; id.lenVar=RT_HW_Base.varToString(var,mode).length();	id.dir=10;} else{id.dir=1; return;}}
if(LcdFuncBefore(id,alig,head,suff))	{return;}
if(LcdFuncLong(id,ago,mode))			{return;}
if(LcdFuncAfter(id,alig,suff))			{return;}};
//=================================================================================================
//							WriteFloat
//=================================================================================================
void LcdWriteFloat(RT_HW_HD44780_PARAM_ID &id, char alig, const char *head, char suff, float &ago, float var, char mode){
if(LcdFuncBegin(id)) 					{return;}
if(id.dir==9){if(ago!=var){id.fresh=1;} 
			  if(id.fresh){ago=var; id.lenVar=RT_HW_Base.varToString(var,mode).length(); 	id.dir=10;} else{id.dir=1; return;}} 
if(LcdFuncBefore(id,alig,head,suff))	{return;}
if(LcdFuncFloat(id,ago,mode))			{return;}
if(LcdFuncAfter(id,alig,suff))		 	{return;}};
//=================================================================================================
//							WriteString
//=================================================================================================
void LcdWriteString(RT_HW_HD44780_PARAM_ID &id, char alig, const char *head, char suff, String &ago, String var, char mode){
if(LcdFuncBegin(id)) 					{return;}
if(id.dir==9){if(ago!=var){id.fresh=1;} 
			  if(id.fresh){ago=var; id.lenVar=RT_HW_Base.getLenSTR(ago,id.len);			     id.dir=10;} else{id.dir=1; return;}}
if(LcdFuncBefore(id,alig,head,suff))	{return;}
if(LcdFuncString(id,ago,mode))			{return;}
if(LcdFuncAfter(id,alig,suff))		 	{return;}};
//=================================================================================================
//							WriteFlicker
//=================================================================================================
void LcdWriteFlicker(RT_HW_HD44780_PARAM_ID &id, char sign='1'){
if(LcdFuncBegin(id))					{return;} 
if(id.dir==9){id.fresh=1; id.flicker=!id.flicker; RT_HW_Base.mess.signBit=sign; id.buff=RT_HW_Base.boolToChar(id.flicker); id.dir=10;}
if(LcdFuncChar(id)) 					{return;}}
//=================================================================================================
//							WriteBit
//=================================================================================================
void LcdWriteBit(RT_HW_HD44780_PARAM_ID &id, bool var, char sign='1'){
if(LcdFuncBegin(id))					{return;}
if(id.dir==9){if(id.agoBool!=var){id.fresh=1;} 
			  if(id.fresh){id.agoBool=var; RT_HW_Base.mess.signBit=sign; id.buff=RT_HW_Base.boolToChar(id.agoBool); id.dir=10;} else{id.dir=1; return;}}
if(LcdFuncChar(id)) 					{return;}}
//=================================================================================================
//							WriteChar
//=================================================================================================
void LcdWriteChar(RT_HW_HD44780_PARAM_ID &id, char &ago, char var){
if(LcdFuncBegin(id))					{return;} 
if(id.dir==9){if(ago!=var){id.fresh=1;} 
			  if(id.fresh){ago=var; id.buff=ago; id.dir=10;} else{id.dir=1; return;}}
if(LcdFuncChar(id)) 					{return;}}
//=================================================================================================

//=================================================================================================
//							WriteText
//=================================================================================================
void LcdWriteText(RT_HW_HD44780_PARAM_ID &id, char alig, const char *pgmText){
if(LcdFuncBegin(id)) 	     			{return;}
if(id.dir==9){if(id.fresh){id.dir=10;} else{id.dir=1;} return;}
if(LcdFuncText(id,alig,pgmText))		{return;};
if(LcdFuncAfter(id,alig,'~'))		 	{return;}};
//==================================================================================================