//-------------------------------------------------------------------------------------------------
//              Сканирование адресов на шине с номером=bus
//-------------------------------------------------------------------------------------------------
void i2cScanNum(uint8_t num){         //==Сканирование адресов на шинах i2c       
RT_HW_Base.consoleBegin();           //--Настройка консоли с параметрами по умолчанию.
if(!RT_HW_Base.console.ok){return;}      //--Проверка на готовность консоли; 
//-------------------------------------------------------------------------------------------------
String str=String(F("i2c::num,bus="))+String(num)+String(',')+String(RT_HW_Base.i2cNumToBus(num))+String(F(" ->"));
if(!RT_HW_Base.WireCheckNum(num))                         {RT_HW_Base.consoleVar(str); RT_HW_Base.consoleVar(String(str+String(F("no num i2c num="))),'E');    return;}   //--Проверка на номер шины i2c;
if( RT_HW_Base.WireGetBitState(RT_HW_I2C_STATE_SLAVE, num)){RT_HW_Base.consoleVar(str); RT_HW_Base.consoleVar(String(F("Slave,no scan")),'E'); return;}
if(!RT_HW_Base.WireGetBitState(RT_HW_I2C_STATE_INIT,  num)){RT_HW_Base.WireBegin(num);  RT_HW_Base.consoleVar(str); RT_HW_Base.consoleVar(String(F("init like a master")),'E');}
if(!RT_HW_Base.WireGetBitState(RT_HW_I2C_STATE_MASTER,num)){RT_HW_Base.consoleVar(str); RT_HW_Base.consoleVar(String(F("no Master")),'E');     return;}
uint8_t qnt=0; RT_HW_Base.consoleVar(str);  
for(uint8_t i=1; i<=127; i++){uint8_t code; RT_HW_Base.WireBeginTransmission(i,num); code=RT_HW_Base.WireEndTransmission(num);  
                  if(code==0){if(qnt>0){RT_HW_Base.consoleVar(',');} qnt++; RT_HW_Base.consoleVar(i,'~',0,'A');}
                  //else {RT_HW_Base.consoleVar(String(F(" adr,err="))); RT_HW_Base.consoleVar(i,',',0,'U'); RT_HW_Base.consoleVar(code,',',0,'U');
                  }                  
if(qnt>0){RT_HW_Base.consoleChar(';');} RT_HW_Base.consoleVar(String(F(" qnt="))); RT_HW_Base.consoleVar(qnt,'E'); return;
};
