//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						Структуры для счетчиков и генераторов
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_CHANGE_PINDI_ID    {uint32_t time; uint8_t dir=0; uint8_t ago=0;};						//--Для защиты от дребезга пина DI;
struct RT_HW_GENERATOR_EVENT_ID {uint32_t time; uint8_t dir=0; uint8_t meander:1, event:1;}; 		//--Для генератора меандров и событий;
struct RT_HW_GENERATOR_PULSE_ID {uint32_t time; int8_t  dir=0;};									//--Для генератора импульсов;
struct RT_HW_GENERATOR_PWM_ID   {uint32_t time; uint32_t timeON; uint32_t timeFULL; uint8_t dir=0;};				//--Для генератора ШИМ;
struct RT_HW_GENERATOR_FRONT_ID {uint32_t time; uint8_t meander, event, ago; uint8_t cnt=1;};		//--Для генератора фронтов;
struct RT_HW_GENERATOR_GROUP_ID {uint32_t time; uint8_t dir=0;    uint8_t cnt=0; uint8_t ago=0; uint8_t meander=0;};	//--Для генератора пачки импульсов;
struct RT_HW_GENERATOR_DELAY_ID {uint32_t time; uint8_t dir=0;    uint8_t cnt=0; uint8_t ago=0;};	//--Для генератора задержек времени;
struct RT_HW_GENERATOR_TASK_ID  {uint32_t time; uint8_t event=0;  uint8_t cnt=0;};					//--Для генератора задач;
struct RT_HW_GENERATOR_DIVIDER_ID{uint8_t  ago; uint8_t state=0; uint8_t cnt=0;};									//--Для делителя событий;
//=================================================================================================