//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								7.Контроллеры программной среды SEEED
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_SEEED_XIAO_M0)				//====КОНТРОЛЛЕР Seeeduino XIAO M0;	 
#define      RT_HW_BOARD_CODE    RT_HW_CODE_BOARD_SEEED_XIAO_M0				//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "Seeeduno XIAO M0"     		//--Наименование платы;
#define      RT_HW_BOARD_SEEED_XIAO_M0										//--Идентификатор типа платы [variant.XIAO_m0];
#define      RT_HW_CORE_SEEED												//--Идентификатор программной среды
#endif
//------Идентификация к группе контроллеров SEEED--------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ARCH_SEEED) 				//--??? Не проверенный идентификатор
#define      RT_HW_CORE_SEEED												//--Идентификатор программной среды										//--Идентификатор программной среды
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								8.Контроллеры программной среды NANO 33
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_NANO_RP2040_CONNECT) 			//====КОНТРОЛЛЕР Arduino Nano RP2040 Connect;	
#define      RT_HW_BOARD_CODE	 RT_HW_CODE_BOARD_NANO_RP2040_CONNECT		//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME            "Arduino Nano RP2040 Connect"     	//--Наименование платы;
#define      RT_HW_BOARD_NANO_RP2040_CONNECT								//--Идентификатор типа платы [aeduino_due_x.variant];
#define      RT_HW_CORE_NANO_33												//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_NANO_33_BLE) 					//====КОНТРОЛЛЕР Arduino Nano RP2040 Connect;	
#define      RT_HW_BOARD_CODE	 RT_HW_CODE_BOARD_NANO_33_BLE				//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME            "Arduino Nano 33 BLE"     			//--Наименование платы;
#define      RT_HW_BOARD_NANO_33_BLE										//--Идентификатор типа платы [aeduino_due_x.variant];
#define      RT_HW_CORE_NANO_33												//--Идентификатор программной среды								//--Наименование архитектуры;
#endif
//------Идентификация к группе контроллеров SAMX---------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ARCH_NANO_33) 			//--??? Не проверенный идентификатор
#define      RT_HW_CORE_NANO_33												//--Идентификатор программной среды										//--Идентификатор программной среды
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								9.Контроллеры программной среды RASPBERRIY PI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_RASPBERRY_PI_PICO)			//====КОНТРОЛЛЕР Seeeduino XIAO M0;	 
#define      RT_HW_BOARD_CODE    RT_HW_CODE_BOARD_RASPBERRY_PI_PICO			//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Raspberry Pi Pico"     	//--Наименование платы;
#define      RT_HW_BOARD_RASPBERRY_PI_PICO									//--Идентификатор типа платы [variant.XIAO_m0];
#define      RT_HW_CORE_RASPBERRY_PI										//--Идентификатор программной среды
#endif
//------Идентификация к группе контроллеров RASPBERRY PI-------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ARCH_RASPBERRY_PI) 				//--??? Не проверенный идентификатор
#define      RT_HW_CORE_RASPBERRY_PI												//--Идентификатор программной среды										//--Идентификатор программной среды
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								10.Контроллеры программной среды PORTENTA H7(M7)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_PORTENTA_H7)					//====КОНТРОЛЛЕР Portenta H7 ;	 
#define      RT_HW_BOARD_CODE    RT_HW_CODE_BOARD_PORTENTA_H7				//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Portenta H7"     			//--Наименование платы;
#define      RT_HW_BOARD_PORTENTA_H7										//--Идентификатор типа платы [variant.XIAO_m0];
#define      RT_HW_CORE_PORTENTA_H7											//--Идентификатор программной среды
#endif
//------Идентификация к группе контроллеров PORTENTA_H7--------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ARCH_RASPBERRY_PI) 		//--??? Не проверенный идентификатор
#define      RT_HW_CORE_PORTENTA_H7											//--Идентификатор программной среды										//--Идентификатор программной среды
#endif
/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 21.Контролеры программной среды (M) STM32F4
// В ядре STM32-Master для контроллеров STM32F4 пока ограниченная поддержка контроллеров STM32F4
// Так STM32F407V нет поддержки WireSlave, Serialx.availableForWrite и др.
// Если ядро будет развиваться, в дальнейшем может быть добавлены необходимые функции
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//generic_f407v
#if !defined(RT_HW_BOARD_CODE) && defined(_BOARD_GENERIC_F407V_H_)			//====КОНТРОЛЛЕР (M)Generic_STM32F407V;	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_BOARD_GENERIC_STM32F407V    //--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME            "(M)Generic_STM32F407V"			//--Наименование платы;
#define      RT_HW_BOARD_GENERIC_STM32F407V_M  								//--Идентификатор типа платы [variant.generic_f407v];
#define      RT_HW_CORE_STM32_M_F4											//--Идентификатор программной среды
#define      RT_HW_CORE_STM32
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_blackpill_f401)				//====КОНТРОЛЛЕР (M)BlackPill F401CCU6		
#define      RT_HW_BOARD_CODE        RT_HW_CODE_M_blackpill_f401        	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(M)BlackPill F401CCU6"		//--Наименование платы;
#define      RT_HW_BOARD_M_blackpill_f401  									//--Идентификатор типа платы [variant.blackpill_f401];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_M_STM32F4											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && (defined(ARDUINO_disco_f411))					//====КОНТРОЛЛЕР (M)BlackPill F401CCU6		
#define      RT_HW_BOARD_CODE        RT_HW_CODE_M_disco_f411       			//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME             "(M)BlackPill F411CE"				//--Наименование платы;
#define      RT_HW_BOARD_M_disco_f411 										//--Идентификатор типа платы [variant.disco_f411];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_M_STM32F4											//--Идентификатор программной среды
#endif
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 22.Контроллеры программной среды (D) STM32F1
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLUEPILL_F103C8) 				//====КОНТРОЛЛЕР (D)BluePill F103C8	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLUEPILL_F103C8       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)BluePill F103C8"			//--Наименование платы;
#define      RT_HW_BOARD_D_BLUEPILL_F103C8 									//--Идентификатор типа платы [variant.PILL_F103XX];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLUEPILL_F103CB) 				//====КОНТРОЛЛЕР (D)BluePill F103CB	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLUEPILL_F103CB       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)BluePill F103CB"			//--Наименование платы;
#define      RT_HW_BOARD_D_BLUEPILL_F103CB 									//--Идентификатор типа платы [variant.PILL_F103XX];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLACKPILL_F103C8) 			//====КОНТРОЛЛЕР (D)BlackPill F103C8	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLACKPILL_F103C8       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)BlackPill F103C8"			//--Наименование платы;
#define      RT_HW_BOARD_D_BLACKPILL_F103C8 								//--Идентификатор типа платы [variant.PILL_F103XX];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLACKPILL_F103CB) 			//====КОНТРОЛЛЕР (D)BlackPill F103CB	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLACKPILL_F103CB       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)BlackPill F103CB"			//--Наименование платы;
#define      RT_HW_BOARD_D_BLACKPILL_F103CB 								//--Идентификатор типа платы [variant.PILL_F103XX];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_GENERIC_F103CBTX) 			//====КОНТРОЛЛЕР (D)Generic F103CBTx	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_GENERIC_F103CBTX       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Generic F103CBTx"			//--Наименование платы;
#define      RT_HW_BOARD_D_GENERIC_F103CBTX 								//--Идентификатор типа платы [variant.STM32F1(xxx/F10CB(T-U)];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_GENERIC_F103RETX) 			//====КОНТРОЛЛЕР (D)Generic F103RETx	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_GENERIC_F103RETX       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Generic F103RETx"			//--Наименование платы;
#define      RT_HW_BOARD_D_GENERIC_F103RETX 								//--Идентификатор типа платы [variant.STM32F1(xxx/F103R(C-D-E)Y)];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_GENERIC_F103VETX) 			//====КОНТРОЛЛЕР (D)Generic F103VETx	 					  
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_GENERIC_F103VETX       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Generic F103VETx"			//--Наименование платы;
#define      RT_HW_BOARD_D_GENERIC_F103VETX 								//--Идентификатор типа платы [variant.STM32F1(xxx/F103V(C-D-E)H-T)];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F1											//--Идентификатор программной среды
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 32.Контроллеры программной среды (D) STM32F4
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLACK_F407VE)					//====КОНТРОЛЛЕР (D)Black F407VE	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLACK_F407VE      		//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Black F407VE"				//--Наименование платы;
#define      RT_HW_BOARD_D_BLACK_F407VE 									//--Идентификатор типа платы [variant.variant_BLACK_F407VX];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F4											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLACK_F407VG)     			//====КОНТРОЛЛЕР (D)Black F407VG	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLACK_F407VG      		//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Black F407VG"				//--Наименование платы;
#define      RT_HW_BOARD_D_BLACK_F407VG 									//--Идентификатор типа платы [variant.variant_BLACK_F407VX];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F4											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_GENERIC_F407VETX)      		//====КОНТРОЛЛЕР (D)Generic F407VETx	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_GENERIC_F407VETX       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Generic F407VETx"			//--Наименование платы;
#define      RT_HW_BOARD_D_GENERIC_F407VETX  								//--Идентификатор типа платы [variant.STM32F4xx/F407];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F4											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_GENERIC_F407VGTX)      		//====КОНТРОЛЛЕР (D)Generic F407VETx	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_GENERIC_F407VGTX       	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Generic F407VGTx"			//--Наименование платы;
#define      RT_HW_BOARD_D_GENERIC_F407VGTX  								//--Идентификатор типа платы [variant.STM32F4xx/F407];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F4											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLACKPILL_F401CC)      		//====КОНТРОЛЛЕР (D)BlackPill F401CC	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLACKPILL_F401CC        	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)BlackPill F401CC"			//--Наименование платы;
#define      RT_HW_BOARD_D_BLACKPILL_F401CC  								//--Идентификатор типа платы [variant.STM32F4xx/_F401C];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F4											//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_BLACKPILL_F411CE)      		//====КОНТРОЛЛЕР (D)BlackPill F411CE	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_BLACKPILL_F411CE        	//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)BlackPill F411CE"			//--Наименование платы;
#define      RT_HW_BOARD_D_BLACKPILL_F411CE  								//--Идентификатор типа платы [variant.STM32F4xx/_F411C];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32F4											//--Идентификатор программной среды
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 10.Контроллеры программной среды STM32duino (H7)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_GENERIC_H743_VITX)			//====КОНТРОЛЛЕР (D)Generic H743VITX	
#define      RT_HW_BOARD_CODE        RT_HW_CODE_D_GENERIC_H743_VITX         //--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                 "(D)Generic H743 VITX"			//--Наименование платы;
#define      RT_HW_BOARD_D_GENERIC_H743_VITX  								//--Идентификатор типа платы [variant.STM32H7xx];
#define      RT_HW_CORE_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32												//--Идентификатор программной среды
#define      RT_HW_CORE_D_STM32H7											//--Идентификатор программной среды
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 Не опознанные контроллеры STM32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//------Идентификация к группе контроллеров STM32---------------------------------------------------
//#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ARCH_STM32)				//--??? Не проверенный идентификатор
//#define      RT_HW_CORE_STM32												//--Идентификатор программной среды		//--Идентификатор программной среды
//#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							90.Контроллеры с не опознанной программной средой 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE)  												//====КОНТРОЛЛЕР неопознанный
#define      RT_HW_BOARD_CODE       RT_HW_CODE_BOARD_ANON        			//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME      "ANON"									//--Наименование платы;
#define      RT_HW_BOARD_ANON  												//--Идентификатор типа платы [variant.STM32H7xx];
#define      RT_HW_CORE_ANON												//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------

//=================================================================================================