//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Структуры работы с 1-WIRE
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
/*
struct RT_HW_STRUCT_ONE_WIRE {
RT_HW_PIN_DIR_ID dd; 
uint8_t custom=0; uint8_t dir=0; uint8_t step=0; uint8_t state; uint8_t bus; 
uint32_t timeDelay; uint8_t stepDelay=0;
unsigned char ROM_NO[8];
uint8_t LastDiscrepancy;
uint8_t LastFamilyDiscrepancy;
bool    LastDeviceFlag;	
};	
*/

//-------------------------------------------------------------------------------------------------
//										API OneWire  
//-------------------------------------------------------------------------------------------------
void 	oneWireBegin	 	(RT_HW_STRUCT_ONE_WIRE &id, uint8_t pin);
void 	oneWireReset	 	(RT_HW_STRUCT_ONE_WIRE &id);
void 	oneWireClear	 	(RT_HW_STRUCT_ONE_WIRE &id);
void 	oneWireDepower	 	(RT_HW_STRUCT_ONE_WIRE &id);
void 	oneWireWriteBit	 	(RT_HW_STRUCT_ONE_WIRE &id, uint8_t v);
void 	oneWireWrite	 	(RT_HW_STRUCT_ONE_WIRE &id, uint8_t v, uint8_t power=0);
//void RT_HW_BASE:: oneWireWrite(RT_HW_STRUCT_ONE_WIRE &id, uint8_t v, uint8_t power) 
void 	oneWireWriteBytes	(RT_HW_STRUCT_ONE_WIRE &id, const uint8_t *buf, uint16_t count, bool power=0);
//void    oneWireWriteBytes   (RT_HW_STRUCT_ONE_WIRE &id, const uint8_t *buf, uint16_t count, bool power)
uint8_t oneWireReadBit	 	(RT_HW_STRUCT_ONE_WIRE &id);
uint8_t oneWireRead		 	(RT_HW_STRUCT_ONE_WIRE &id);
void    oneWireReadBytes 	(RT_HW_STRUCT_ONE_WIRE &id, uint8_t *buf, uint16_t count);
void 	oneWireSelect	 	(RT_HW_STRUCT_ONE_WIRE &id, const uint8_t rom[8]);
void 	oneWireSkip		 	(RT_HW_STRUCT_ONE_WIRE &id);
void 	oneWireTargetSearch	(RT_HW_STRUCT_ONE_WIRE &id, uint8_t family_code);
bool 	oneWireSearch		(RT_HW_STRUCT_ONE_WIRE &id, uint8_t *newAddr, bool search_mode);