//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Настройка параметров устройства
// Вызов функции в проекте:
//	if(id.dir==0){
//    id.event.periodBlink=RT_HW_hd_44780.timeToTick(<Период мерцания>);  	//--***Настройка периодичности мерцний полями;
//    id.codeSign=<Код набора символов для bool>;							//--***Табличный код (0-9);
//	  RT_HW_hd44780.LcdSetParam(id,num,col,row,periodOut,mode);}			//--Вызов функции настройки;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void LcdSetParamOut(RT_HW_HD44780_PARAM_ID  &id, uint8_t num, char mode, char modeOutput, uint16_t periodLimitLow, uint8_t col, uint8_t row, uint8_t len=0){
id.custom=0;														//--Очистка флага готовности
id.output=id.clear=id.run=id.agoBool=id.flicker=0;					//--Очистка флагов;
id.mode=mode;														//--Тип выводимой переменной;
id.modeOutput=modeOutput;											//--Режим вывода;
id.periodLimitLow=RT_HW_Base.timeToTick(periodLimitLow,RT_HW_HD44780_PERIOD_TICK);	//--Период вывода - лимит нижний;
if(!checkNum(num)) {return;}										//--Контроль на допустимость num;
id.num=num;															//--Сохранение номера устройства; 
if(col>ptr[id.num]->cols) {id.col=ptr[id.num]->cols;} else{id.col=col;}	//--Сохранение номера колонки с ограничением диапазона;
if(row>ptr[id.num]->rows) {id.row=ptr[id.num]->rows;} else{id.row=row;}	//--Сохранение номера строки  с ограничением диапазона;
if(row>ptr[id.num]->rows) {return;}									//--Сохранение номера строки  с ограничением диапазона;
id.vCursor=pointCursor(id.num,id.col,id.row); 
uint8_t buff=ptr[id.num]->cols-id.col+1; 							//--Вычисляем максимальную длину допустимого поля;
if((len==0)||(len>buff)){id.len=buff;}		      else{id.len=len;}	//--Установка длины поля;
id.curChip=1; if((ptr[id.num]->chip==2)&&(id.row>2)){id.curChip=2;}	//--Установка номера чипа выводимого поля;
id.runOutput=id.first=id.fistLine=1;								//--Установка флагов;
id.custom=1;														//--Установка флага готовности;
}; 																	//--Завершение настройки;
//=================================================================================================

