//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//				1.[Begin] Check conditions for begin output or clear fields
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool LcdFuncBegin(RT_HW_HD44780_PARAM_ID  &id){
//RT_HW_Base.consoleVar(String(F("1.Gen LcdFuncBegin")),'E');
LcdGenerator(id);													//--Call tick generator;
if(id.dir==0) {if(!id.custom)  		  	{return 1;} id.dir=1;}		//--waiting custom ID 
if(id.dir==1) {if(id.output==0)		    {return 1;} id.output=0;	//--check flag output;    
			   if(id.clear==0){id.dir=9; return 0;}  				//--goto output field
			   id.clear=0;     id.dir=3;} 							//--goto clear field;		
//------------------------------------------------------------------------------------------------
//					Clear field
//------------------------------------------------------------------------------------------------
if(id.dir==3) {if(ptr[id.num]->busy){return 1;}	ptr[id.num]->busy=1; id.run=1; id.index=id.len; id.dir=5;}      //--capture lcd; 
if(id.dir==5) {if(deviceSend(id.num,id.curChip,id.vCursor,'I',RT_HW_HD44780_TIME_CURSOR)){id.dir++;} return 1;}	//--set cursor; 
if(id.dir==6) {if(id.index==0){ptr[id.num]->busy=0; id.run=0;                             id.dir=1;  return 1;}	//--backtrack after clear;  
			   if(deviceSend(id.num,id.curChip,RT_HW_HD44780_BLANK,'D')){id.index--;}  				 return 1;}	//--send code for clear;
																									 return 0;} //--for random errors;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Output before variable
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool LcdFuncBefore(RT_HW_HD44780_PARAM_ID &id, char alig, const char *head, char suff){
//--------Calc parameters--------------------------------------------------------------------------
if(id.dir==10){id.outStart=1; id.fresh=0; id.indexSrc=0;
			   if(getCharLcdPGM(head,id.indexSrc)==RT_HW_BREAK_CHAR){id.lenHead=0;} else{id.lenHead=RT_HW_Base.getLenPGM(head,id.len);} //--set head's length;
			   if(suff!='~') {id.lenSuff=1;} else {id.lenSuff=0;}											//--set         suff's length;	   
			   if(id.mode=='T'){id.lenHead=id.lenSuff=0;}													//--for mode=TEXT clear size field var,suff;
			   if((id.lenHead+id.lenVar+id.lenSuff)>id.len)  {id.lenSuff=0;}								//--normalizing suff's lenght;
			   do{if(((id.lenHead+id.lenVar)<=id.len) ||(id.lenHead==0)) {break;} id.lenHead--;} while(1);	//--normalizing head's length;		   
			   do{if(((id.lenVar)           <=id.len) ||(id.lenVar==0))  {break;} id.lenVar--;}  while(1); 	//--normalizing var's  length;																	//--init parameters;		   
			   //if(id.mode=='T'){return 0;}																	//--for mode=TEXT return 0;
				//if((id.mode=='B') || (id.mode=='*'))
				//{			   
			  // uint8_t arr[4]; arr[0]=id.len; arr[1]=id.lenHead; arr[2]=id.lenVar; arr[3]=id.lenSuff;
			//	RT_HW_Base.consoleVar(String(F("FuncBefore alig=")));        RT_HW_Base.consoleVar(alig,',');
			 //   RT_HW_Base.consoleVar(String(F(" len->len,head,var,suff=")));RT_HW_Base.consoleArrVar(arr,'E',0,'U',4);
			  //}	
			   id.dir++;}
//--------Set cursor------------------------------------------------------------------------------- 
if(id.dir==11){if(checkSetBusy(id.num)){return 1;} id.run=1; id.dir++; return 1;}									//--awaiting release Lcd;-
if(id.dir==12){if(!deviceSend(id.num,id.curChip,id.vCursor,'I',RT_HW_HD44780_TIME_CURSOR)){return 1;} id.dir=15;}	//--Set cursor;  
//--------Output head------------------------------------------------------------------------------
if(id.dir==15){id.index=0; id.indexSrc=0; id.flagBuff=1; id.dir++;}
if(id.dir==16){if(id.index>=id.lenHead)  {id.dir++;  									return 1;} 									    
			   if(id.flagBuff){id.flagBuff=0; id.buff=getCharLcdPGM(head,id.indexSrc);}	
			   if(deviceSend(id.num,id.curChip,id.buff,'D')){id.flagBuff=1; id.index++;}return 1;}
//--------Output blank before variable-------------------------------------------------------------
if(id.dir==17){id.index=RT_HW_Base.getLenBegin((id.len-id.lenHead),(id.lenVar+id.lenSuff),alig); id.flagBuff=1; id.dir++;
				//uint8_t arr[5]; arr[0]=id.len; arr[1]=id.lenHead; arr[2]=id.lenVar; arr[3]=id.lenSuff; arr[4]=id.index;
				//RT_HW_Base.consoleVar(String(F("alig,len,head,var,suff,index="))); RT_HW_Base.consoleVar(alig,',');
			    //RT_HW_Base.consoleArrVar(arr,'E',0,'U',5);
}
if(id.dir==18){if(id.index==0){id.flagBuff=1; id.index=0; id.indexSrc=0; id.dir=30; 	return 1;}
			   if(deviceSend(id.num,id.curChip,RT_HW_HD44780_BLANK,'D')){id.index--;}   return 1;} 
																						return 0;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Output after variable
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool LcdFuncAfter(RT_HW_HD44780_PARAM_ID &id, char alig, char suff='~'){
if(id.dir==40){if(id.lenSuff) {id.buff=suff; id.dir++;} else {id.dir=42;}}
if(id.dir==41){if(deviceSend(id.num,id.curChip,id.buff,'D')) {id.dir=42;} 				return 1;}
if(id.dir==42){id.index=RT_HW_Base.getLenEnd((id.len-id.lenHead),(id.lenVar+id.lenSuff),alig); id.flagBuff=1; id.dir++;}
if(id.dir==43){if(id.index==0){id.flagBuff=1; id.index=0;     id.dir=50;  				return 1;}
			   if(deviceSend(id.num,id.curChip,RT_HW_HD44780_BLANK,'D')){id.index--;} 	return 1;}
if(id.dir==50){clearBusy(id.num); id.run=0; 							 id.dir=1;   	return 1;}	 			//--end output char;
																						return 0;}

//#################################################################################################
//=================================================================================================
//							Output char
//=================================================================================================
bool LcdFuncChar(RT_HW_HD44780_PARAM_ID &id){
if(id.dir==10){id.fresh=0;													   id.dir++;   return 1;}
if(id.dir==11){if(checkSetBusy(id.num)){return 1;} id.run=1;                   id.dir++;   return 1;}				//--awaiting release Lcd;-
if(id.dir==12){if(!deviceSend(id.num,id.curChip,id.vCursor,'I',RT_HW_HD44780_TIME_CURSOR)){return 1;} id.dir=15;}	//--Set cursor; 
if(id.dir==15){if( deviceSend(id.num,id.curChip,id.buff,'D'))      			  {id.dir=50;} return 1;} 				//--output char;
if(id.dir==50){clearBusy(id.num); id.run=0; 								   id.dir=1;   return 1;}	 			//--end output char;
return 1;}
//=================================================================================================
//							Output byte
//=================================================================================================
bool LcdFuncByte(RT_HW_HD44780_PARAM_ID &id, uint8_t &ago, char mode, char sign='X'){			
if(id.dir==30){if(id.index>=id.lenVar){id.dir=40; return 1;}
			   if(id.flagBuff){id.flagBuff=0; 
				if(mode=='X'){if(sign=='X') {id.buff=ptr[id.num]->codeBlack;} else {id.buff=sign;}}
				else 		 {RT_HW_Base.mess.signBit=sign; RT_HW_Base.mess.qntBit=id.lenVar;
				              String str=RT_HW_Base.varToString(ago,mode); id.buff=getCharLcdSTR(str,id.indexSrc);}}
																						 id.dir++; 	return 1;}	
if(id.dir==31){if(deviceSend(id.num,id.curChip,id.buff,'D')) {id.flagBuff=1; id.index++; id.dir--;} return 1;} 
																									return 0;}
//=================================================================================================
//							Output word
//=================================================================================================
bool LcdFuncWord(RT_HW_HD44780_PARAM_ID &id, int16_t &ago, char mode){			
if(id.dir==30){if(id.index>=id.lenVar){id.dir=40; return 1;} 	
			   if(id.flagBuff){id.flagBuff=0; String str=RT_HW_Base.varToString(ago,mode);	id.buff=getCharLcdSTR(str,id.indexSrc);} 
			   id.dir++; return 1;}
if(id.dir==31){if(deviceSend(id.num,id.curChip,id.buff,'D')) {id.flagBuff=1; id.index++; id.dir--;} return 1;} 
return  0;}
//=================================================================================================
//							Output long
//=================================================================================================
bool LcdFuncLong(RT_HW_HD44780_PARAM_ID &id, int32_t &ago, char mode){			
if(id.dir==30){if(id.index>=id.lenVar){id.dir=40; return 1;}
			   if(id.flagBuff){id.flagBuff=0; String str=RT_HW_Base.varToString(ago,mode);	id.buff=getCharLcdSTR(str,id.indexSrc);} id.dir++; return 1;}
if(id.dir==31){if(deviceSend(id.num,id.curChip,id.buff,'D')) {id.flagBuff=1; id.index++; id.dir--;} return 1;} 
return 0;}				
//=================================================================================================
//							Output float
//=================================================================================================
bool LcdFuncFloat(RT_HW_HD44780_PARAM_ID &id, float &ago, char mode){			
if(id.dir==30){if(id.index>=id.lenVar){id.dir=40; return 1;}
			   if(id.flagBuff){id.flagBuff=0; String str=RT_HW_Base.varToString(ago,mode);	id.buff=getCharLcdSTR(str,id.indexSrc);} id.dir++; return 1;}
if(id.dir==31){if(deviceSend(id.num,id.curChip,id.buff,'D')) {id.flagBuff=1; id.index++; id.dir--;} return 1;} 
return 0;}
//=================================================================================================
//							Output String
//=================================================================================================
bool LcdFuncString(RT_HW_HD44780_PARAM_ID &id, String &ago, char mode){			
if(id.dir==30){if(id.index>=id.lenVar){id.dir=40; return 1;}
			   if(id.flagBuff){id.flagBuff=0; String str=RT_HW_Base.varToString(ago,mode);	id.buff=getCharLcdSTR(str,id.indexSrc);} id.dir++; return 1;}				
if(id.dir==31){if(deviceSend(id.num,id.curChip,id.buff,'D')) {id.flagBuff=1; id.index++; id.dir--;} return 1;} 
return 0;}				
//=================================================================================================
//							Output Text
//=================================================================================================
bool LcdFuncText(RT_HW_HD44780_PARAM_ID &id,  char alig, const char *pgmText){
//--------Calc parameters--------------------------------------------------------------------------
if(id.dir==10){id.outStart=1; id.fresh=0;  id.lenHead=0; id.lenSuff=0;
			   if(getCharLcdPGM(pgmText,id.indexSrc)==RT_HW_BREAK_CHAR){id.lenVar=0;} else{id.lenVar=RT_HW_Base.getLenPGM(pgmText,id.len);} //--set head's length;
			   do{if(((id.lenVar)           <=id.len) ||(id.lenVar==0))  {break;} id.lenVar--;}  while(1); 	//--normalizing var's  length;	   	
			   id.dir++;}
//--------Set cursor------------------------------------------------------------------------------- 
if(id.dir==11){if(checkSetBusy(id.num)){return 1;} id.run=1; id.dir++; return 1;}	//--awaiting release Lcd;-
if(id.dir==12){if(!deviceSend(id.num,id.curChip,id.vCursor,'I',RT_HW_HD44780_TIME_CURSOR)){return 1;} id.dir=15;} 
//--------Output blank before variable-------------------------------------------------------------
if(id.dir==15){id.index=RT_HW_Base.getLenBegin((id.len-id.lenVar),0,alig); id.flagBuff=1; id.dir++;}
if(id.dir==16){if(id.index==0){id.flagBuff=1; id.index=0; 				id.dir=17; 		return 1;}
			   if(deviceSend(id.num,id.curChip,RT_HW_HD44780_BLANK,'D')){id.index--;}   return 1;} 			   
//--------Output pgmText----------------------------------------------------------------------------
if(id.dir==17){id.index=0; id.indexSrc=0; id.flagBuff=1; id.dir++;}
if(id.dir==18){if(id.index>=id.lenVar)  {id.dir=20;  									return 1;} 									    
			   if(id.flagBuff){id.flagBuff=0; id.buff=getCharLcdPGM(pgmText,id.indexSrc);}	
			   if(deviceSend(id.num,id.curChip,id.buff,'D')){id.flagBuff=1; id.index++;}return 1;}																						
//--------Output blank after variable---------------------------------------------------------------
if(id.dir==20){id.index=RT_HW_Base.getLenBegin((id.len-id.lenVar),0,alig); id.flagBuff=1; id.dir++;}
if(id.dir==21){if(id.index==0){id.flagBuff=1; id.index=0; 				id.dir=50; 		return 1;}
			   if(deviceSend(id.num,id.curChip,RT_HW_HD44780_BLANK,'D')){id.index--;}   return 1;} 		   
if(id.dir==50){clearBusy(id.num); id.run=0; 							 id.dir=1;   	return 1;}
																						return 0;}
//=================================================================================================
