 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 								Вычисление адреса курсора
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t  pointCursor  (uint8_t num, uint8_t vCol, uint8_t vRow){
uint8_t cols=ptr[num]->cols;		//--Установка кол-во колонок;
uint8_t rows=ptr[num]->rows;		//--Установка кол-во строk
uint8_t row=vRow;
uint8_t col=vCol;
//if(row>rows){row=rows;}; if(row<1) {row=1;} row--;
//if(col>cols){col=cols;}; if(col<1) {col=1;} col--;
row=constrain(row,1,rows)-1;
col=constrain(col,1,cols)-1;
uint8_t adr=0; 
//-------------------------------------------------------------------------------------------------
if(ptr[num]->cols==16){if(ptr[num]->rows==1){if(col<=8) {adr=col;} else {adr=8+col;}}
				  else{uint8_t row_offsets[] = {0x00,0x40,0x10,0x50}; adr=col+row_offsets[row];}}  	
if(ptr[num]->cols==20){uint8_t row_offsets[] = {0x00,0x40,0x14,0x54}; adr=col+row_offsets[row];}   	
if(ptr[num]->cols==40){uint8_t row_offsets[] = {0x00,0x40,0x00,0x40}; adr=col+row_offsets[row];}             
//-------------------------------------------------------------------------------------------------
bitSet(adr,7); 
//-------------------------------------------------------------------------------------------------
return adr;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает код символа (из таблицы(PROGMEM) перекодировки utf-8 в коды lcd
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t getCodeCharLcdPGM(uint8_t code){
	return pgm_read_byte(RT_HW_HD44780_CONVERT_RUS+code);};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает номер символа из utf-8
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t convert(uint8_t charH, uint8_t charL){
if(charH==0xD0) {if (charL==0x81) {return 0x40;}  if((charL>=0x90) && (charL<=0xBF)){return (charL-0x90);}};
if(charH==0xD1) {if (charL==0x91) {return 0x41;}  if((charL>=0x80) && (charL<=0x8F)){return (charL-0x50);}}; return charL;}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает следующий код(utf-8) из String;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t getCharLcdSTR(String &str, uint8_t &indexSrc){						
uint8_t buff1=str[indexSrc]; uint8_t buff2=0; indexSrc++; 
if(buff1>=0xC0) {buff2=str[indexSrc];  indexSrc++; return getCodeCharLcdPGM(convert(buff1,buff2));} else {return buff1;}}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает следующий код(utf-8) из PROGMEM;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t getCharLcdPGM(const char *text, uint8_t &indexSrc)  {
uint8_t buff1=pgm_read_byte(text+indexSrc);; uint8_t buff2=0; indexSrc++;
if(buff1>=0xC0) {buff2=pgm_read_byte(text+indexSrc); indexSrc++; return getCodeCharLcdPGM(convert(buff1,buff2));} 
else            {return buff1;}}

/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает код символа (из таблицы(PROGMEM) перекодировки utf-8 в коды lcd
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t getCodeCharLcdPGM(uint8_t code){
	return pgm_read_byte(RT_HW_HD44780_CONVERT_RUS+code);};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает номер символа из utf-8
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t convert(uint8_t charH, uint8_t charL){
if(charH==0xD0) {if (charL==0x81) {return 0x40;}  if((charL>=0x90) && (charL<=0xBF)){return (charL-0x90);}};
if(charH==0xD1) {if (charL==0x91) {return 0x41;}  if((charL>=0x80) && (charL<=0x8F)){return (charL-0x50);}}; return charL;}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает следующий код(utf-8) из String;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t getCharLcdSTR(String &str, uint8_t index){						
uint8_t buff1,buff2,num; num=index;
buff2=0; buff1=str[num]; num++; 
if(buff1>=0xC0) {buff2=str[num];  num++; return getCodeCharLcdPGM(convert(buff1,buff2));} else {return buff1;}}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 						Возвращает следующий код(utf-8) из PROGMEM;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t getCharLcdPGM(const char *text, uint8_t index)  {
uint8_t buff1,buff2,num; num=index; 
buff2=0; buff1=pgm_read_byte(text+num); num++; 
if(buff1>=0xC0) {buff2=pgm_read_byte(text+num); num++; return getCodeCharLcdPGM(convert(buff1,buff2));} 
else            {return buff1;}}
*/
//=================================================================================================
/*
//-------------------------------------------------------------------------------------------------
//			       Возвращает кол-во заполнителей спереди для выравнивания заполняемого поля
//                      (alig=L,C,R,N, len=длина строки, sz=длина заполняемого поля);
//-------------------------------------------------------------------------------------------------
uint8_t getLenBegin(uint8_t len,uint8_t sz,char alig){
if(len<=sz)  {return 0;} 
if(alig=='C'){return (len-sz-(len-sz)/2);}
if(alig=='R'){return (len-sz);}	return 0;};  
//-------------------------------------------------------------------------------------------------
//			       Возвращает кол-во заполнителей сзади для выравнивания заполняемого поля
//                      (alig=L,C,R,N, len=длина строки, sz=длина заполняемого поля);
//-------------------------------------------------------------------------------------------------
uint8_t getLenEnd  (uint8_t len,uint8_t sz,char alig){//==Получение кол-ва заполнителей сзади;	
if(len<=sz)  {return 0;}
if(alig=='C'){return (len-sz-getLenBegin(len,sz,alig));}
if(alig=='L'){return (len-sz);}               return 0;}
//-------------------------------------------------------------------------------------------------
// 					Возвращает длину текста из String  в формате utf-8 с учетом блокирующего символа '~'
//-------------------------------------------------------------------------------------------------
uint8_t getLenSTR(String &str,  uint8_t lenMax){ 							
uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=str[j];	         if(buff>=0xC0) {j++; buff=str[j];}  j++;	
if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;} len++;} return len;}
//-------------------------------------------------------------------------------------------------
// 					Возвращает длину текста из PROGMEM в формате utf-8 с учетом блокирующего символа '~'
//-------------------------------------------------------------------------------------------------
uint8_t getLenPGM(const char *text, uint8_t lenMax){						//==Возвращает len textPGM(utf-8) с учетом блокирующего символа '~');
	uint8_t buff,j,len; if(lenMax==0) {lenMax=40;} j=len=0;
while (1) {buff=pgm_read_byte(text+j);	j++;
		   if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;}
		   if(buff>=0xC0) {j++; buff=pgm_read_byte(text+j);} len++;} return len;}

*/


/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	3.3. Возвращает длину String  в формате utf-8 (с учетом блокирующего символа RT_HW_LCD_HD44780_BREAK_CHAR '~')
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_LCD_HD44780:: getLenSTR(String &str, uint8_t lenMax){uint8_t buff,j,LEN; if(lenMax==0) {lenMax=40;} j=LEN=0;
while (1) {buff=str[j];	         if(buff>=0xC0) {j++; buff=str[j];}  j++;	
if((buff==0) || (buff==RT_HW_LCD_HD44780_BREAK_CHAR) || (LEN>lenMax) || (j>160)) {break;} LEN++;} return LEN;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	2.6.4. Возвращает длину текста из PROGMEM  в формате utf-8 c с учетом символа RT_HW_LCD_HD44780_BREAK_CHAR '~'
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_LCD_HD44780:: getLenPGM(const char *text, uint8_t lenMax){uint8_t buff,j,LEN; if(lenMax==0) {lenMax=40;} j=LEN=0;
while (1) {buff=pgm_read_byte(text+j);	j++;
		   if((buff==0) || (buff==RT_HW_LCD_HD44780_BREAK_CHAR) || (LEN>lenMax) || (j>160)) {break;}
		   if(buff>=0xC0) {j++; buff=pgm_read_byte(text+j);} LEN++;} return LEN;}
		   */